



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【BZOJ】【1912】【APIO2010】patrol巡逻</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【BZOJ】【1912】【APIO2010】patrol巡逻</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 01:46:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>树形DP</h1>
<hr />
<p>　　说是树形DP，其实就是求树的最长链嘛&hellip;&hellip;</p>
<p>　　K=1的时候明显是将树的最长链的两端连起来最优。</p>
<p>　　但是K=2的时候怎么搞？</p>
<p>　　考虑第一次找完树的最长链以后的影响：第一次找过的边如果第二次再走，对答案的贡献会变成-1，因为两次都选这一段的话，反而会使得这一段不得不走两次（如果只被选一次的话就可以只走一次），所以就将第一次找出的树的最长链上的边权值都改为-1。这个操作可以用链表实现（类比一下最小费用最大流的spfa实现！）</p>
<p>　　题解：<a href="http://blog.csdn.net/qpswwww/article/details/43935861" rel="external nofollow noreferrer">http://blog.csdn.net/qpswwww/article/details/43935861</a></p>
<div>
<div>
<pre class="prettyprint linenums"> /**************************************************************<br />
     Problem: 1912<br />
     User: Tunix<br />
     Language: C++<br />
     Result: Accepted<br />
     Time:580 ms<br />
     Memory:5752 kb<br />
 ****************************************************************/

 //BZOJ 1912<br />
 #include&lt;vector&gt;<br />
 #include&lt;cstdio&gt;<br />
 #include&lt;cstring&gt;<br />
 #include&lt;cstdlib&gt;<br />
 #include&lt;iostream&gt;<br />
 #include&lt;algorithm&gt;<br />
 #define rep(i,n) for(int i=0;i&lt;n;++i)<br />
 #define F(i,j,n) for(int i=j;i&lt;=n;++i)<br />
 #define D(i,j,n) for(int i=j;i&gt;=n;--i)<br />
 #define pb push_back<br />
 #define CC(a,b) memset(a,b,sizeof(a))<br />
 using namespace std;<br />
 inline int getint(){<br />
     int v=,sign=; char ch=getchar();<br />
     while(ch&lt;''||ch&gt;''){ if (ch=='-') sign=-; ch=getchar();}<br />
     while(ch&gt;=''&amp;&amp;ch&lt;=''){ v=v*+ch-''; ch=getchar();}<br />
     return v*sign;<br />
 }<br />
 const int N=1e5+,INF=~0u&gt;&gt;;<br />
 typedef long long LL;<br />
 /******************tamplate*********************/<br />
 int head[N],to[N&lt;&lt;],next[N&lt;&lt;],len[N&lt;&lt;],cnt=;<br />
 void add(int x,int y){<br />
     to[++cnt]=y; next[cnt]=head[x]; head[x]=cnt; len[cnt]=;<br />
     to[++cnt]=x; next[cnt]=head[y]; head[y]=cnt; len[cnt]=;<br />
 }<br />
 int n,K;<br />
 int D,S,son1[N],son2[N];<br />
 int dfs(int x,int fa){<br />
     int m1=,m2=;<br />
     for(int i=head[x];i;i=next[i])<br />
         if (to[i]!=fa){<br />
             int nowh=dfs(to[i],x)+len[i];<br />
             if (nowh&gt;m1){m2=m1;m1=nowh;son2[x]=son1[x];son1[x]=i;}<br />
             else if (nowh&gt;m2){m2=nowh; son2[x]=i;}<br />
         }<br />
     if (D&lt;m1+m2) D=m1+m2,S=x;<br />
     return m1;<br />
 }<br />
 int main(){<br />
 #ifndef ONLINE_JUDGE<br />
     freopen("1912.in","r",stdin);<br />
     freopen("1912.out","w",stdout);<br />
 #endif<br />
     n=getint(); K=getint();<br />
     F(i,,n){<br />
         int x=getint(),y=getint();<br />
         add(x,y);<br />
     }<br />
     int ans=(n-)&lt;&lt;;<br />
     D=;<br />
     CC(son1,-);<br />
     CC(son2,-);<br />
     dfs(,-);<br />
     ans-=D-;<br />
     if (K&gt;){<br />
         D=;<br />
         for(int i=son1[S];i!=-;i=son1[to[i]]) len[i]=len[i^]=-;<br />
         for(int i=son2[S];i!=-;i=son1[to[i]]) len[i]=len[i^]=-;<br />
         CC(son1,-);<br />
         CC(son2,-);<br />
         dfs(,-);<br />
         ans-=D-;<br />
     }<br />
     printf("%d\n",ans);<br />
     return ;<br />
 }
 </pre>
</div>
</div>
<h2>1912: [Apio2010]patrol 巡逻</h2>
<p>Time Limit: 4 Sec&nbsp;&nbsp;Memory Limit: 64 MB<br />Submit: 642&nbsp;&nbsp;Solved: 362<br />[<a href="http://www.lydsy.com/JudgeOnline/submitpage.php?id=1912" rel="external nofollow noreferrer">Submit</a>][<a href="http://www.lydsy.com/JudgeOnline/problemstatus.php?id=1912" rel="external nofollow noreferrer">Status</a>][<a href="http://www.lydsy.com/JudgeOnline/bbs.php?id=1912" rel="external nofollow noreferrer">Discuss</a>]</p>
<h2>Description</h2>
<div><img referrerpolicy="no-referrer"src="http://www.lydsy.com/JudgeOnline/images/1912_1.jpg" />
</div>
<h2>Input</h2>
<div>第一行包含两个整数 n, K(1 &le; K &le; 2)。接下来 n &ndash; 1行，每行两个整数 a, b，<br />
表示村庄a与b之间有一条道路(1 &le; a, b &le; n)。 </div>
<h2>Output</h2>
<div>输出一个整数，表示新建了K 条道路后能达到的最小巡逻距离。 </div>
<h2>Sample Input</h2>
<div>8 1 <br />
1 2 <br />
3 1 <br />
3 4 <br />
5 3 <br />
7 5 <br />
8 5 <br />
5 6 </div>
<h2>Sample Output</h2>
<div>11</div>
<h2>HINT</h2>
<div>
<p>10%的数据中，n &le; 1000,    K = 1； <br />
30%的数据中，K = 1； <br />
80%的数据中，每个村庄相邻的村庄数不超过 25； <br />
90%的数据中，每个村庄相邻的村庄数不超过 150； <br />
100%的数据中，3 &le; n &le; 100,000, 1 &le; K &le; 2。</p>
</div>
<h2>Source</h2>
<p>[<a href="http://www.lydsy.com/JudgeOnline/submitpage.php?id=1912" rel="external nofollow noreferrer">Submit</a>][<a href="http://www.lydsy.com/JudgeOnline/problemstatus.php?id=1912" rel="external nofollow noreferrer">Status</a>][<a href="http://www.lydsy.com/JudgeOnline/bbs.php?id=1912" rel="external nofollow noreferrer">Discuss</a>]</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8km31r9.html">用Java实现简单的web服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdmv00q.html">hdu 1150 最小点覆盖</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnddpoq.html">CountDownLatch，一个同步辅助类，在完成一组正在其他线程中执行的操作之前，它允许一个或多个线程一直等待。</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xg6kr9.html">向Oracle数据库中插入数据出错：ORA-01036 无效的变量名或数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo37y1q.html">Python优缺点</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z7zre9.html">poj2912 Rochambeau</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpl7vj9.html">Nginx 配置对流量、连接和请求的限制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjzxyj8.html">Python的logging日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj25gr8.html">Runnable和Callable之间的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp233xq.html">centos 桌面没有有线设置，不能上网</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2vpzo9.html">通过type类型 新建对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdlg3v9.html">&lbrack;PA2012&rsqb; Tax</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r57d4eq.html">基于ARM9和嵌入式Linux系统的多功能综合通信控制系统的框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyjg1gq.html">Collections集合工具类的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyym7gxq.html">tar&period;gz和&period;rpm包的区别与使用&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv3d2k8.html">mybatis学习 十一 缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko1el7q.html">【LOJ】&num;2278&period; 「HAOI2017」字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp53x09.html">分布式tensorflow</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jodmr8.html">Jmeter数据库mysql测试说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndv4r28.html">CentOS7下配置FTP服务</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93xp76g9.html">c语言学习的第10天</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zv4oz9.html">Centos6&period;5环境下安装SVN  整合Apache&plus;SSL</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1mwne9.html">php简单缓存类</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wkyjlq.html">复习后台代码（与前面clentHttp连接网络结合）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvve32xq.html">centos  yum 安装问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1n4438.html">android 特效UI实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1kexx9.html">Laravel 5 基础（八）- 模型、控制器、视图基础流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdejr109.html">自定义获取html元素对象的7种方法。</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o34py9.html">&period;Net异步编程之Async与Await的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7me3zxq.html">MVC中Model，不仅仅只是数据的传递者</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
